BINDING_HEADER_WANMARK = "WanMark"
_G["BINDING_NAME_CLICK WanMark:Mark"] = "To Mark Group"
_G["BINDING_NAME_CLICK WanMark:Mode"] = "To Change Mode"
_G["BINDING_NAME_CLICK WanMark:DeMark"] = "To Remove Marks"

local ADDON_NAME, namespace = ... 	--localization
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local addoninfo = 'v'..version
local WanMark, gdbprivate = ...

--local WanMarkDB.WanMarkMode = "public"

gdbprivate.gdbdefaults = {
}
gdbprivate.gdbdefaults.gdbdefaults = {
}

----------------------------
-- Saved Variables Loader --
----------------------------
local loader = CreateFrame("Frame")
	loader:RegisterEvent("ADDON_LOADED")
	loader:SetScript("OnEvent", function(self, event, arg1)
		if event == "ADDON_LOADED" and arg1 == "WanMark" then
			local function initDB(gdb, gdbdefaults)
				if type(gdb) ~= "table" then gdb = {} end
				if type(gdbdefaults) ~= "table" then return gdb end
				for k, v in pairs(gdbdefaults) do
					if type(v) == "table" then
						gdb[k] = initDB(gdb[k], v)
					elseif type(v) ~= type(gdb[k]) then
						gdb[k] = v
					end
				end
				return gdb
			end
			WanMarkDB = initDB(WanMarkDB, gdbprivate.gdbdefaults) --the first per account saved variable. The second per-account variable DCS_ClassSpecDB is handled in DCS_Layouts.lua
			gdbprivate.gdb = WanMarkDB --fast access for checkbox states
			self:UnregisterEvent("ADDON_LOADED")
			if (WanMarkDB.WanMarkMode == nil) then
				WanMarkDB.WanMarkMode = "public"
			end
		end
	end)

local WanMark, private = ...

private.defaults = {
}
private.defaults.dcsdefaults = {
}

WanMark = {};

----------------------------
-- Saved Variables Loader --
----------------------------
local loader = CreateFrame("Frame")
	loader:RegisterEvent("ADDON_LOADED")
	loader:SetScript("OnEvent", function(self, event, arg1)
		if event == "ADDON_LOADED" and arg1 == "WanMark" then
			local function initDB(db, defaults)
				if type(db) ~= "table" then db = {} end
				if type(defaults) ~= "table" then return db end
				for k, v in pairs(defaults) do
					if type(v) == "table" then
						db[k] = initDB(db[k], v)
					elseif type(v) ~= type(db[k]) then
						db[k] = v
					end
				end
				return db
			end
			WanMarkDBPC = initDB(WanMarkDBPC, private.defaults) --saved variable per character, currently not used.
			private.db = WanMarkDBPC
			self:UnregisterEvent("ADDON_LOADED")
		end
	end)

----------------------------------
-- WanMark: Public, Private, Main
----------------------------------

local function WMARK_Mark_Public()
	local ROLEMARKS={["TANK"]=4,["HEALER"]=1}
	for i=1,5 do 
		local role=UnitGroupRolesAssigned("party"..i)
		if ROLEMARKS[role]then 
			SetRaidTarget("party"..i,ROLEMARKS[role])
			--print(i, role)
		end 
	end
	local currentSpecID, currentSpecName = GetSpecializationInfo(GetSpecialization())
	--print("Your current spec:", currentSpecName)
	--print("Your current spec ID:", currentSpecID)
	local roleToken = GetSpecializationRoleByID(currentSpecID)
	--print(roleToken)
	if ROLEMARKS[roleToken]then 
		SetRaidTarget("player", ROLEMARKS[roleToken])
	end
end

local function WMARK_Mark_Private()
	--local PMARKS={["Homika"]=1,["Ziri"]=1,["Jeena"]=1,["Juliemao"]=1,["Lileh"]=1,["Fuzzy"]=1,["Lonarwen"]=3,["Valtherion"]=3,["Wan"]=4,["Wandal"]=4,["Wandead"]=4,["Wanhun"]=4,["Wanbah"]=4,["Wanshoo"]=4,["Braemyr"]=5,["Aoth"]=5,["Kordannon"]=5,["Rommus"]=5,["Chubble"]=5,["Xshadowlock"]=7,["Xdrud"]=7,["Xhunta"]=7,["Xfuzzbow"]=7,["Xfuzzishock"]=7,["Xmage"]=7}
	local PMARKS={}
	-- none
	local LINE0=""
	-- star
	local LINE1="Homika Ziri Jeena Juliemao Lileh Fuzzy"
	-- circle
	local LINE2=""
	-- Diamond
	local LINE3="Lonarwen Valtherion"
	-- triangle
	local LINE4="Wan Wandal Wandead Wanbah Wanshoo Wanhun"
	-- moon
	local LINE5="Braemyr Aoth Kordannon Rommus Chubble"
	-- square
	local LINE6=""
	-- Cross
	local LINE7="Xhunta Xshadowlock Xdrud Xfuzzbow Xfuzzishock Xmage"
	-- Skull
	local LINE8=""
	--####
	for i in LINE0:gmatch("%w+") do PMARKS[i]=0 end
	for i in LINE1:gmatch("%w+") do PMARKS[i]=1 end
	for i in LINE2:gmatch("%w+") do PMARKS[i]=2 end
	for i in LINE3:gmatch("%w+") do PMARKS[i]=3 end
	for i in LINE4:gmatch("%w+") do PMARKS[i]=4 end
	for i in LINE5:gmatch("%w+") do PMARKS[i]=5 end
	for i in LINE6:gmatch("%w+") do PMARKS[i]=6 end
	for i in LINE7:gmatch("%w+") do PMARKS[i]=7 end
	for i in LINE8:gmatch("%w+") do PMARKS[i]=8 end
	--####
	for i=1,5 do
		local pName=UnitName("party"..i)
		if PMARKS[pName]then
			SetRaidTarget("party"..i,PMARKS[pName])
		end
	end
	local playerName = UnitName("player");
	--print("name:", playerName);
	if PMARKS[playerName]then
		SetRaidTarget("player",PMARKS[playerName])
	end
end

local function WMARK_Mark()
	if IsInRaid() then 
		print("WanMark: no marking in raid.")
		return
	elseif IsInGroup() then
		if (WanMarkDB.WanMarkMode == "private") then
			WMARK_Mark_Private()
		else
			WMARK_Mark_Public()
		end
		print("WanMark has marked the targets, mode:", WanMarkDB.WanMarkMode)
	else
		print("WanMark: not in group or raid ("..WanMarkDB.WanMarkMode.." mode).")
	end
end

------------------
-- WanMark DeMark
------------------

local function WMARK_DeMark()
	if IsInRaid() then 
		return
	elseif IsInGroup() then
		for i=1,5 do 
			SetRaidTarget("party"..i,0)
		end
	end
	SetRaidTarget("player", 0)
	print("WanMark removed party marks.")
end

local WanMarkFrame = CreateFrame("Frame", "WanMarkFrame", UIParent)

WanMarkFrame:SetScript("OnEvent", function(self, event, ...)
	WMARK_Mark()
end)

----------------
-- WanMark Mode
----------------

local function WMARK_Mode()
	if (WanMarkDB.WanMarkMode == "private") then
		WanMarkDB.WanMarkMode = "public"
	else
		WanMarkDB.WanMarkMode = "private"
	end
	print("WanMark Mode changed to", WanMarkDB.WanMarkMode)
end

-----------------------
-- WMARK Slash Setup --
-----------------------
local RegisteredEvents = {};
local wmarkslash = CreateFrame("Frame", "WanMarkSlash", UIParent)

wmarkslash:SetScript("OnEvent", function (self, event, ...) 
	if (RegisteredEvents[event]) then 
	return RegisteredEvents[event](self, event, ...) 
	end
end)

function RegisteredEvents:ADDON_LOADED(event, addon, ...)
	if (addon == "WanMark") then
		--SLASH_WANMARK1 = (L["/wmark"])
		SLASH_WANMARK1 = "/wmark"
		SlashCmdList["WANMARK"] = function (msg, editbox)
			WanMark.SlashCmdHandler(msg, editbox)	
	end
	--	DEFAULT_CHAT_FRAME:AddMessage("WanMark loaded successfully. For options: Esc>Interface>AddOns or type /wmark.",0,192,255)
	end
end

for k, v in pairs(RegisteredEvents) do
	wmarkslash:RegisterEvent(k)
end

function WanMark.ShowHelp()
	print(addoninfo)
	print("WanMark Slash commands (/wmark):")
	print("  /wmark on: Enables WanMark automatic mode.")
	print("  /wmark off: Disables WanMark automatic mode.")
	print("  /wmark mark: Marks the targets regardless of automatic mode status.")
	print("  /wmark demark: Removes any party members marks.")
	print("  /wmark private: Enables private (default) marking mode (Revelation).")
	print("  /wmark public: Enables public marking mode (Tank/Healer).")
	print("  /wmark mode: Switches marking mode between private and public.")
end

function WanMark.SlashCmdHandler(msg, editbox)
    msg = string.lower(msg)
	--print("command is " .. msg .. "\n")
	--if (string.lower(msg) == L["config"]) then --I think string.lowermight not work for Russian letters
	if (msg == "on") then
		WanMarkFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
		WanMarkFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
		WanMarkFrame:RegisterEvent("INSPECT_READY")
		print("WanMark automatic mode has been turned on (", WanMarkDB.WanMarkMode, ").")
	elseif (msg == "off") then
		WanMarkFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
		WanMarkFrame:UnregisterEvent("GROUP_ROSTER_UPDATE")
		WanMarkFrame:UnregisterEvent("INSPECT_READY")
		print("WanMark automatic mode has been turned off.")
		gdbprivate.gdb.gdbdefaults = gdbprivate.gdbdefaults.gdbdefaults
	elseif (msg == "mark") then
		WMARK_Mark()
		gdbprivate.gdb.gdbdefaults = gdbprivate.gdbdefaults.gdbdefaults
	elseif (msg == "demark") then
		WMARK_DeMark()
	elseif (msg == "private") then
		if (WanMarkDB.WanMarkMode == "public")then
			WMARK_Mode()
		end
	elseif (msg == "public") then
		if (WanMarkDB.WanMarkMode == "private")then
			WMARK_Mode()
		end
	elseif (msg == "mode") then
		WMARK_Mode()
	else
		WanMark.ShowHelp()
	end
end
	SlashCmdList["WANMARK"] = WanMark.SlashCmdHandler;

-- toggle frame, has no visible parts. exists as a place to accept a click run a snippet
local toggleframe = CreateFrame("Button","WanMark",UIParent,"SecureHandlerClickTemplate")
	toggleframe:RegisterForClicks("AnyDown")
	toggleframe:SetScript("OnClick", function (self, button, down)
		if (button == "Mark")then
			WMARK_Mark()
		elseif (button == "Mode")then
			WMARK_Mode()
		elseif (button == "DeMark")then
			WMARK_DeMark()
		end
	end)
